<template>
  <div class="md-layout">
    <div class="md-layout-item md-size-100">
      <h4 class="card-title">Seleziona un'immagine per la segnalazione</h4>
      <div class="file-input">

        <div class="image-container" v-if="issue.issueImagePreview">
          <img :src="issue.issueImagePreview" />
        </div>
        <div class="button-container">
          <md-button class="md-danger md-round" @click="removeImage" v-if="issue.issueImagePreview"><i class="fa fa-times"></i>Remove</md-button>
          <md-button class="md-success md-round md-fileinput">
            <template v-if="!issue.issueImagePreview">Seleziona un'immagine</template>
            <template v-else>Cambia</template>
            <!--<input id="file-input" type="file" @change="onMediaSelected($event.target.name, $event.target.files)">-->
            <input type="file" @change="onFileChange">
          </md-button>
        </div>
      </div>
    </div>
    <div class="md-layout-item md-size-100">
      <h4 class="card-title">Geolocalizzazione</h4>
      <md-button @click="getLocation">
        <i class="fa fa-map-marker-alt"></i>
      </md-button>
      <h3 class="card-title" v-if="issue.coordinates.length > 0">
        longitudine: {{issue.coordinates[0]}}
        latitudine: {{issue.coordinates[1]}}
      </h3>
    </div>
    <div class="md-layout-item md-size-100" style="margin-bottom: 20px">
      <h4 class="card-title">In alternativa puoi cercare l'indirizzo</h4>
      <vue-google-autocomplete
        id="map-autocomplete"
        placeholder="Inserisci l'indirizzo"
        v-on:placechanged="getAddressData"
      >
      </vue-google-autocomplete>
    </div>

  </div>
</template>

<script>

  import VueGoogleAutocomplete from 'vue-google-autocomplete'
  export default {
    name: "IssueConfigStep",
    props: ['issue'],
    data: function () {
      return {}
    },
    methods: {
      getLocation: function () {
        if ("geolocation" in navigator) {
          navigator.geolocation.getCurrentPosition((position) => {
            console.log(position);
            this.issue.coordinates.push(position.coords.longitude);
            this.issue.coordinates.push(position.coords.latitude);
          });
        } else {
          /* la geolocalizzazione NON È disponibile */
        }
      },
      getAddressData: function (addressData, placeResultData, id) {
        this.issue.typedAddress= `${addressData.route}, ${addressData.street_number || '#'}, ${addressData.postal_code || '#####'} ${addressData.locality || ''}, ${addressData.country || ''}`
      },
      validate: function () {
        return true;
      },
      onFileChange(e) {
        let files = e.target.files || e.dataTransfer.files;
        if (!files.length) return;
        this.issue.picture = files[0];
        this.createImage(files[0]);
      },
      createImage(file) {
        let reader = new FileReader();
        let vm = this;
        reader.onload = (e) => {
          vm.issue.issueImagePreview = e.target.result;
        };
        reader.readAsDataURL(file);
      },
      removeImage: function () {
        this.issue.issueImagePreview = '';
      },
    },
    components: {
      VueGoogleAutocomplete
    }
  }
</script>

<style scoped>
  #map-autocomplete {
    width: 100%;
    padding: 10px 0;
  }

</style>
